      include 'dgflt.f'
      program resampcca2
c program to resample, multiplex and mask the microtremor data observed 
c independently & simultaneously.
c
c				                Jun,18,2008 T. Yokoi, IISEE, BRI
c
c Modified for double screening: by peak/rms and 
c                                by deviation of rms from average
c                                 May,12,2009 T. Yokoi, IISEE, BRI
c Modified for multiplexed input data file
c                                 Apr,13,2010 T. Yokoi, IISEE, BRI
      parameter(nmax=225000,nch0=7,nblk0=16384,mblk0=2000,n_mea0=50)
      character filen*80,cfn(n_mea0)*12,cout*10,comment*80,
     *          cform1*15,cform2*20,cform3*18,cform4*18
c      character cdrv*3,cwkf*10
      character cdrv*2,cwkf*9
      real*4 x(nmax,nch0),xx(nmax),y(nblk0,nch0),peak(nch0),rmsa(nch0),
     *       rms(mblk0,nch0),aver(nch0),sgm(nch0)
      integer iflg(mblk0),mblkmea(n_mea0)
c     data cdrv/'../'/ 
      data cdrv/'./'/ 
c      write(6,*)'cdrv=',cdrv
c default values
      data fl,fh,fs/0.05,10.,12./ ap,as/0.1,10.0/ ajudge/4./
     *     a_sgm/2/ ph0/0.0/
c Chebishev I, Lowpass (2) Bandpass(3), Causal
      data ntype,nchara,ncausal/2,2,1/
c working folder name
      cwkf=cdrv//'ccawkf/'
c      cwkf=cdrv
c      write(6,*)'cwkf=',cwkf
c temporary file name
      open(12,status='scratch')
c
      filen=cwkf//'prm/resampcca2.prm'
      open(10,file=filen,status='old')
      write(6,*)' Working Folder=',cwkf
c channel number, initial azimuth, sampling interval, resampling rate
      read(10,*) nch,ph0,dt,nskip
      fnyquist=1./(2.*dt*real(nskip))
      fs=fnyquist*0.9
      fh=fs*0.9
      dt1=dt*nskip
      write(6,*)' Nch=',nch
      write(6,*)' Nskip=',nskip,' f(Nyquist)=',fnyquist,' fh=',fh
      call formatter(nch,cform1,cform2,cform3,cform4)
      read(10,*) nch_center,rr
      read(10,*) ajudge,a_sgm
      write(6,*)' ajudge=', ajudge,' a_sgm=',a_sgm
c start and end time 
      read(10,*) tst,tdur
      write(6,*) tst,tdur
      nst0=int(tst/dt)+1
      ndur0=int(tdur/dt+0.5)
c      ndur0=int(tdur/dt)+1
      scale=1.0
c output file name
      read(10,*)cout
      write(6,*)cout
c number of data in one time block after resampling
      read(10,*) nblk
c number of measurement in the same array configuration
      read(10,*)n_mea
c     write(6,*)n_mea,'-files are processed'
      write(6,*)' First screening (peak/rms<',ajudge,'):'
c
      do i_mea=1,n_mea
       write(6,*)i_mea,'-th measurement:'
       ndat=ndur0/nskip
c input file names
       read(10,*)cfn(i_mea)
       filen=cwkf//'data/ascii_files/'//cfn(i_mea)
       write(6,*)filen
       open(1,file=filen,status='old')
       read(1,*)nch00,dt00,scale00,ndata00
       if(nch00.ne.nch) then
	  write(6,*)' nch does not coincide, check the file.'
        stop
       endif
       if(dt00.ne.dt) then
	  write(6,*)' dt does not coincide, check the file.'
        stop
	 endif
       if(ndata00.gt.ndur0) then
	  write(6,*)' ndata does not coincide, check the file.'
	  write(6,*)ndata00,ndur0
        stop
	 endif
	 read(1,'(a80)')comment
c	 write(6,*)comment
       do i=1,ndur0
        read(1,*,end=111) xdum,(x(i,j),j=1,nch)
       enddo
  111  ndur0=i-1
c      write(6,*)ndur0
       if(nskip.ge.2) then
	  do j=1,nch
         do i=1,ndur0
          xx(i)=x(i,j)
         enddo
c
         sum=0.0
         nnave=ndur0/10.
         do i=1,nnave
          sum=sum+xx(i)
         enddo
         ave=sum/real(nnave)
         do i=1,ndur0
          xx(i)=xx(i)-ave
         enddo
         ntaper=nnave/10
         do i=1,ntaper+1
          xx(i)=xx(i)*real(i-1)/real(ntaper)
         enddo         
c
         call bandp1(xx,ndur0,dt,fl,fh,fs,ap,as,ntype,nchara,ncausal)
c
         do i=1,ndat
          x(i,j)=xx((i-1)*nskip+1)
         enddo
        enddo
       endif
ccccccccccccccccccccccccccccccccccccccccccccccccccccccc!
c 2.0E-09 = 1 count tosite discretize    
      mmm=0
      if(mmm.gt.0) then							
       an=2.0E-04				        		
       do j=1,nch							
        do i=1,ndur0							
         x(i,j)=nint(x(i,j)/an)*an	      			 
        enddo							
       enddo							
      endif							
c Keta Ochi Test: x(i,j)						
      nnn=0								
      if(nnn.gt.0) then							
       an=10.**real(nnn)						
       do j=1,nch							
        do i=1,ndur0							
         x(i,j)=real(int(x(i,j)*an))/an				 
        enddo							
       enddo							
      endif							
ccccccccccccccccccccccccccccccccccccccccccccccccccccccc!
c first screening using the maximum value/rms amplitude
       iblkmx=0
       mblk=0
       iblk=0
       ist=0
  100  continue
c time block start and end
       if(ist.ne.0) then
        ist=ist+nblk/2
       else
        ist=1
       endif
       ied=ist+nblk-1
c escape from loop
       if(ied.gt.ndat) goto 200
       iblk=iblk+1
       do k=1,nblk
        do ich=1,nch
         y(k,ich)=x(ist+k-1,ich)
        enddo
       enddo
c peak value
       do ich=1,nch
        peak(ich)=abs(y(1,ich))
        do k=2,nblk
         if(peak(ich).lt.abs(y(k,ich))) peak(ich)=abs(y(k,ich))
        enddo
c rms amplitude
        sum=0.
        do k=1,nblk
         sum=sum+y(k,ich)**2
        enddo
        rmsa(ich)=sqrt(sum/nblk)
       enddo
c max. value of the ratio=peak/rms over channels
       aratio=peak(1)/rmsa(1)
       do ich=2,nch
        if(aratio.lt.peak(ich)/rmsa(ich)) aratio=peak(ich)/rmsa(ich)
       enddo
c screening
       iblkmx=iblkmx+1
       if(aratio.lt.ajudge) then
        iflg(iblk)=1
        mblk=mblk+1
       else
        iflg(iblk)=0
       endif
c
       goto 100
  200  continue
       write(6,*) mblk,' blocks remained among ',iblkmx,' blocks'
c store in the temporary file
       ist=0
       do	iblk=1,iblkmx
        if(iblk.eq.1) then
         write(12,cform2)nch,mblk,ph0,(cfn(ich),ich=1,nch)
c         write(12)nch,mblk,ph0,(cfn(ich),ich=1,nch)
        endif
c time block start and end
        if(ist.ne.0) then
         ist=ist+nblk/2
        else
         ist=1
        endif
        ied=ist+nblk-1
c
        if(iflg(iblk).eq.1) then
         do i=ist,ied
          t=dt1*real(i-1)
          write(12,cform3)i,t,(x(i,ich),ich=1,nch)
c          write(12)i,t,(x(i,ich),ich=1,nch)
         enddo
        endif
c end of do loop over iblk
       enddo
c end of do loop over i_mea
      enddo
      write(6,*)' Data stored in the temporary file'
c average and variance of rms amplitude
      rewind(12)
      mmblk=0
      do i_mea=1,n_mea
       read(12,'(4x,i4)') mblk
c       read(12) n_dum,mblk,adum,(cdum(ich),ich=1,nch)
       do iblk=1,mblk
        do k=1,nblk
         read(12,cform3)i,t,(y(k,ich),ich=1,nch)
c        write(6,cform3)i,t,(y(k,ich),ich=1,nch)
c         read(12)i,t,(y(k,ich),ich=1,nch)
c         if(k.eq.1)    tst=t
c         if(k.eq.nblk) ted=t
        enddo
c rms amplitude
        do ich=1,nch
         sum=0.
         do k=1,nblk
          sum=sum+y(k,ich)**2 
         enddo
         rms(iblk+mmblk,ich)=sqrt(sum/real(nblk))
        enddo
c end of do loop over iblk
       enddo
       mmblk=mmblk+mblk
c end of do loop over i_mea
      enddo
c
      do ich=1,nch
       sum=0.
       do iblk=1,mmblk
        sum=sum+rms(iblk,ich)
       enddo
c average rms amplitude
       aver(ich)=sum/real(mmblk)
       sum=0.
       do iblk=1,mmblk
        sum=sum+(rms(iblk,ich)-aver(ich))**2
       enddo
       var=sum/real(mmblk-1)
c standard deviation
       sgm(ich)=sqrt(var)
      enddo
      mmblk0=mmblk
c
      filen=cwkf//'data/resampled_files/'//cout
      write(6,*)filen
      open(2,file=filen,status='unknown')
c screening using SD of rms amplitude
      rewind(12)
      icount=0
      iii=0
      do i_mea=1,n_mea
       read(12,'(4x,i4)') mblkmea(i_mea)
c       read(12) n_dum,mblkmea(i_mea),adum,(cdum(ich),ich=1,nch)
       do iblk=1,mblkmea(i_mea)
        do k=1,nblk
         read(12,cform4)t,(y(k,ich),ich=1,nch)
c         read(12)t,(y(k,ich),ich=1,nch)
         if(k.eq.1) tst=t
        enddo
c rms amplitude
        icount=icount+1
        iflg(icount)=1
        do ich=1,nch
         sum=0.
         do k=1,nblk
          sum=sum+y(k,ich)**2 
         enddo
         rrmss=sqrt(sum/real(nblk))
         if(abs(aver(ich)-rrmss).gt.a_sgm*sgm(ich)) then
          mmblk=mmblk-iflg(icount)
          iflg(icount)=0
         endif
        enddo
        if(iflg(icount).eq.1) iii=iii+1
c end of do loop over iblk
       enddo
c end of do loop over i_mea
      enddo
      if(icount.gt.mblk0) then
       write(6,*)'icount=',icount,', mblk0=',mblk0
       write(6,*)'icount>mblk0!, Use bigger mblk0.'
       stop
      endif
c	write(6,*)mmblk,iii,icount
      rewind(12)
      icount=0
      iii=0
      do i_mea=1,n_mea
       read(12,*)
c       read(12) n_dum,m_dum,adum,(cdum(ich),ich=1,nch)
       do iblk=1,mblkmea(i_mea)
        do k=1,nblk
         read(12,cform4)t,(y(k,ich),ich=1,nch)
c         read(12)t,(y(k,ich),ich=1,nch)
         if(k.eq.1) tst=t
        enddo
        if(i_mea.eq.1.and.iblk.eq.1) then
         write(2,'(i2,2i5,i2,2f8.2,1x,a18,1x,a40)') 
     *      nch,mmblk,nblk,nch_center,ph0,rr,cform3,
     *    ':nch,mmblk,nblk,nch_center,ph0,rr,cform3'
c 							
        endif        
        icount=icount+1
        if(iflg(icount).eq.1) then
         iii=iii+1
         do k=1,nblk
          if(abs(y(k,ich)).gt.1.e5) then
           write(6,*)' Overflow! Use bigger scale factor.'
           stop
     	  endif
         enddo
         do k=1,nblk
          t=tst+real(k-1)*dt1
          write(2,cform3)k,t,(y(k,ich),ich=1,nch)
         enddo
        else
c        write(6,*)
c    *   ' A block is skipped at i_mea=',i_mea,' and iblk=',iblk
        endif
c end of do loop over iblk
       enddo
c end of do loop over i_mea
      enddo
      write(6,*)
     *' Second screening ({rms-average(rms)}/sigma<',a_sgm,'):'
      write(6,*)mmblk,' blocks remained among ',mmblk0,' blocks'
      close(12)
      close(2)
      close(10)
c
      stop
      end
c+++++
      subroutine formatter(nch,cform1,cform2,cform3,cform4)
      character cform1*15,cform2*20,cform3*18,cform4*18
      if(nch.ge.10) then
       write(cform1,'(a4,i2,a9)')'(1x,',nch,'(a12,1x))'
       write(cform2,'(a10,i2,a8)')'(2i4,f8.2,',nch,'(6x,a8))'
       write(cform3,'(a10,i2,a6)')'(i6,f12.4,',nch,'e15.7)'
       write(cform4,'(a10,i2,a6)')'(6x,f12.4,',nch,'e15.7)'
      else if(nch.ge.3) then
       write(cform1,'(a4,1x,i1,a9)')'(1x,',nch,'(a12,1x))'
       write(cform2,'(a10,1x,i1,a8)')'(2i4,f8.2,',nch,'(6x,a8))'
       write(cform3,'(a10,1x,i1,a6)')'(i6,f12.4,',nch,'e15.7)'
       write(cform4,'(a10,1x,i1,a6)')'(6x,f12.4,',nch,'e15.7)'
      else
       write(6,*)'nch should be bigger than 2!'
      endif
      end
